



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ2178 圆的面积并（simpson积分）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ2178 圆的面积并（simpson积分）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 01:19:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　板子题。可以转一下坐标防止被卡。精度和常数实在难以平衡。</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;cstdlib&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;algorithm&gt;<br />
using namespace std;<br />
#define ll long long<br />
#define double long double<br />
#define N 1010<br />
char getc(){char c=getchar();while ((c&lt;'A'||c&gt;'Z')&amp;&amp;(c&lt;'a'||c&gt;'z')&amp;&amp;(c&lt;'0'||c&gt;'9')) c=getchar();return c;}<br />
int gcd(int n,int m){return m==0?n:gcd(m,n%m);}<br />
int read()<br />
{<br />
    int x=0,f=1;char c=getchar();<br />
    while (c&lt;'0'||c&gt;'9') {if (c=='-') f=-1;c=getchar();}<br />
    while (c&gt;='0'&amp;&amp;c&lt;='9') x=(x&lt;&lt;1)+(x&lt;&lt;3)+(c^48),c=getchar();<br />
    return x*f;<br />
}<br />
int n;<br />
const double PI=acos(-1.0);<br />
double x[N],y[N],r[N];<br />
struct data<br />
{<br />
    double x;int op;<br />
    bool operator &lt;(const data&amp;a) const<br />
    {<br />
        return x&lt;a.x;<br />
    }<br />
}a[N&lt;&lt;1];<br />
const double eps=1E-7;<br />
double f(double k)<br />
{<br />
    int m=0;<br />
    for (int i=1;i&lt;=n;i++)<br />
    if (fabs(x[i]-k)&lt;r[i])<br />
    {<br />
        double t=sqrt(r[i]*r[i]-(x[i]-k)*(x[i]-k));<br />
        a[++m].x=y[i]-t,a[m].op=1;<br />
        a[++m].x=y[i]+t,a[m].op=-1;<br />
    }<br />
    sort(a+1,a+m+1);<br />
    double ans=0,cur;int u=0;<br />
    for (int i=1;i&lt;=m;i++)<br />
    {<br />
        if (u==0) cur=a[i].x;<br />
        u+=a[i].op;<br />
        if (u==0) ans+=a[i].x-cur;<br />
    }<br />
    return ans;<br />
}<br />
double simpson(double l,double r)<br />
{<br />
    return (r-l)*(f(l)+f(r)+4*f((l+r)/2))/6;<br />
}<br />
double calc(double l,double r,double simp)<br />
{<br />
    double mid=(l+r)/2,x=simpson(l,mid),y=simpson(mid,r);<br />
    if (fabs(x+y-simp)&lt;eps) return x+y;<br />
    else return calc(l,mid,x)+calc(mid,r,y);<br />
}<br />
int main()<br />
{<br />
#ifndef ONLINE_JUDGE<br />
    freopen("bzoj2178.in","r",stdin);<br />
    freopen("bzoj2178.out","w",stdout);<br />
    const char LL[]="%I64d\n";<br />
#else<br />
    const char LL[]="%lld\n";<br />
#endif<br />
    n=read();double L=2000,R=-2000;<br />
    for (int i=1;i&lt;=n;i++)<br />
    {<br />
        x[i]=read(),y[i]=read(),r[i]=read();<br />
        double u=x[i]*sin(PI/3)+y[i]*cos(PI/3),v=x[i]*cos(PI/3)-y[i]*sin(PI/3);<br />
        x[i]=u,y[i]=v;<br />
        L=min(L,x[i]-r[i]),R=max(R,x[i]+r[i]);<br />
    }<br />
#undef double<br />
    printf("%.3f",(double)calc(L,R,simpson(L,R)));<br />
    return 0;<br />
}
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m7wkr8.html">poj 2777</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kwp4r8.html">IOS开发中滑动页面时NSTimer停止的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyp41mq.html">poj1125最短路</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmmrze9.html">Difference between Hard Clip（H） and Soft Clip（S） in Samtools CIGAR string</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ymkwnq.html">tcpdump dns包（linux高性能编程读书笔记2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z13mmn9.html">SQL SERVER中架构的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v41j48.html">HOWTO re</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xnxvz8.html">戴尔笔记本win8&period;1&plus;UEFI下安装Ubuntu14&period;04过程记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydno3mq.html">&period;NET 操作PDF文档以及PDF文件打印摸索总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1kvrk9.html">颜色rgb</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4m0lq.html">如何断开eclipse与svn的链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x5l4v8.html">JS HTML DOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkw72v8.html">Docker学习笔记&lpar;3&rpar; &mdash; docker仓库的镜像怎么删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkjdod8.html">【Flask】 项目结构说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1e71l9.html">L - Vases and Flowers HDU - 4614  线段树&plus;二分</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w7k6gq.html">ASP&period;NET Core 之 Identity</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwydr48.html">get方式传值中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/960n6my9.html">&lbrack;LeetCode&rsqb; 620&period; Not Boring Movies&lowbar;Easy tag&colon; SQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4vl0k9.html">【spring源码分析】spring和&commat;PostConstruct注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o443d1q.html">关于 HTTP GET&sol;POST 请求参数长度最大值的一个理解误区</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gy0j0q.html">Android学习之基础知识十三 &mdash; 四大组件之服务详解第二讲&lpar;完整版的下载示例&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdxkpv9.html">Omi框架学习之旅 - 之开篇扯蛋</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvxoyk8.html">Ionic App中嵌入外部网页的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4255z9.html">&lbrack;Oracle&rsqb;快速构造大量数据的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1ov3xq.html">随机森林和GBDT的几个核心问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv02338.html">springmvc 解决 controller 中出现死循环并 stackoverflow 的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwe3dz8.html">Jmeter&lpar;三十二&rpar;&lowbar;搭建本地接口自动化环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r2yr68.html">oracle系统化学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jw7njq.html">A&period; Make a triangle&excl;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jw7kjq.html">CF 1047 C&period; Enlarge GCD</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
